/*******************************************************************
 *******************************************************************

 Class: FTT-Ethernet                                  
 Type:  FTT Ethernet example application
 Platform: Shark
 Name: eg_rm_m.c
 
 By: Paulo Pedreiras
 Date: 2003-Ago-1
 Description: Configures a set of synchronous messages
              Uses Rate Monotonic scheduler
              Master component

 Log: (Date,Author,description)Comments:

 ********************************************************************
 ********************************************************************/


  /*******************************************/
 /*   FTT related defines and includes      */
/*******************************************/

#include "fttm1_0.h"

/********************************/
/* main()                       */
/********************************/

int main(int argc, char **argv)
{

  /* FTT global vars initialization */
  EC_LEN=20000; /* EC length (us) */
  tm_seqn=0; /* Initial value for Trigger Message sequence number */
   
  /* Auxiliary variable used to append messages to the SRT */
  SRDB_SRT_mesgtype SRT_aux_var; 
  
    /***********************/
   /* Init the ftt system */
  /***********************/
  ftt_minit();
  
    /**************************/
   /* Set-up the message set */
  /**************************/
  
  cprintf("\n --------------------------");
  cprintf("\n |  Example program (RM)  |");
  cprintf("\n --------------------------");

  cprintf("\n Building synchronous message set ...");

  SET_SMESG_PROP(&SRT_aux_var,1,100,1,1,0); /* id, size, period, deadline, init */ 
  SRDB_SRT_addmesg(&SRT_aux_var);

  SET_SMESG_PROP(&SRT_aux_var,2,100,1,1,0); /* id, size, period, deadline, init */
  SRDB_SRT_addmesg(&SRT_aux_var);

  SET_SMESG_PROP(&SRT_aux_var,3,1024,2,2,0); /* id, size, period, deadline, init */ 
  SRDB_SRT_addmesg(&SRT_aux_var);

  SET_SMESG_PROP(&SRT_aux_var,4,1024,5,5,0); /* id, size, period, deadline, init */
  SRDB_SRT_addmesg(&SRT_aux_var);


  cprintf(" Finished!");
 
  /* Print the initial message set */
  /* Synchronous messages */
  cprintf("\n Synchronous message set:");
  SRDB_SRT_printmesg();
  cprintf("\n Any key to continue");
  keyb_getchar();

  /* Asynchronous messages */
  cprintf("\n Asynchronous message set:");
  SRDB_ART_printmesg();
  cprintf("\n Any key to continue");
  keyb_getchar();
  
    /*****************************************/
   /* Messages configured. Start the system */
  /*****************************************/
  ftt_mstart();

  
  /* Main task ends but system does not shutdown since there are active tasks */
  return 0;

}
